// TODO: Musicdef

local HU = hurryup

/*
FOR MODDERS THAT ARE READING THIS:
the list below is the only thing that should matter for u :)

example: {"displayname","music"}
how to add your music to the list: table.insert(HU.MusicList,{"ohmygod","omg"})

~lu
*/
HU.MusicList = {
	{"SonicBTS","HURY01"},
	{"SonicBTS2","HURY02"},
	{"SonicAdvance2","HURY03"},
	{"Sonic4","HURY04"},
	{"HedgehogMusic","HURY05"},
	{"SonicTheFighters","HURY06"},
	{"Cuphead","HURY07"},
	{"JSAB","HURY08"}
	{"AntonBlast","HURY09"}
	{"AHatInTime","HURY10"}
	{"WarioLand4","HURY11"}
	{"PizzaTowerLap1","HURY12"}
	{"PizzaTowerLap2","HURY13"}
	{"PizzaTowerLap3","HURY14"}
}

HU.IsInList = function(tofind,table,targetindex)
	if not (tofind and table and targetindex)
		return print("\x82WARNING:\x80 bruh (an external mod didn't read line 37 of KL_HurryUp.../Lua/1-Init/HurryTunes.lua)")
	end
	for index=1, #table do
		if tofind == table[index][targetindex]:lower() then return index end
	end
end

HU.HurryTunes = COM_AddCommand("hu_hurrytunes", function(p, arg)
	arg = tostring(arg):lower()
	local num = tonumber(arg)
	local random = false
	
	if (num and num<0) then num = nil end
	
	if (arg == "random" or num == 0)
		random = true
	else
		if num != nil
			if num>#HU.MusicList then return CONS_Printf(p, "\131* We don't have that many songs! O_o") end
			arg = HU.MusicList[num][1]
		end
		local found = HU.IsInList(arg,HU.MusicList,1) or HU.IsInList(arg,HU.MusicList,2)
		if (arg and found)
			num = found
			arg = HU.MusicList[found][1]
		elseif arg != "nil" and not num
			return CONS_Printf(p, "\131* Song not found :(  Check your spelling? Or use ID instead.")
		end
	end
	
	if random or (num and arg)
		if random 
			p.votepref = 0
			p.voteprefcfg = "random"
		else
			p.votepref = num
			p.voteprefcfg = arg
		end
		local displaytext = tostring(p.voteprefcfg):upper()
		CONS_Printf(p, "\131* Hurry Up music has been changed to \130" .. displaytext .. "\131.")
		S_StartSound(nil, sfx_radio, p)
		S_StartSound(nil, sfx_kc5e, p)
		if tpsloaded == true then WriteTPSconfig(p) end
	else
		local choices = ""
		for i=1, #HU.MusicList do
			choices = $+"\n"+HU.MusicList[i][1]
		end
		CONS_Printf(p, "\131* Please choose between:\130\nRandom"+choices)
		S_StartSound(nil, sfx_radio, p)
	end
end,0)

HU.PlayTunes = function()
	for p in players.iterate do
		p.randomhurrymusic = HU.SelectedRandom or 0
		p.currentmusic = $ or "none"
		p.currentmusic = S_MusicName()
		p.currentmusic = tostring(p.currentmusic):lower()
		p.voteprefcfg = $ or "random"
		p.votepref = $ or 0
		--CONS_Printf(p, p.currentmusic)
		local mus = p.votepref or p.randomhurrymusic
		if mus
			COM_BufInsertText(p,"tunes "..HU.MusicList[mus][2])
		end
	end
end