//moved hurrytunes to hurrytunes.lua

local HU = hurryup

--HU.pinchmusic = "HURRY0"
HU.racecountup = 0

HU.doPinch = function()
	HU.IsIntermission = false
	if not HU.enabled.value return end
	local host = server or players[0]
	if host.XITdoomsday then return end
	
	if racecountdown and racecountdown > 1 then
		HU.Happened = true
	
		//Pinch music
		if HU.ShuffleNext then
			HU.SelectedRandom = A_RandomRange(1,#HU.MusicList)
			HU.ShuffleNext = false
		end
		
		for player in players.iterate do
			if not player.heardpinch then
				--COM_BufInsertText(player,"tunes "..HU.pinchmusic) //[old method]
				--playtunes() //[new method]
				HU.PlayTunes() //[even newer method]
				player.heardpinch = true
			end
		end
		
		//Extra alarm sounds every ~10 seconds
		if (racecountdown % 350 == 0) or (racecountdown == 245)
			S_StartSound(nil,sfx_dwnind)
		elseif (racecountdown == (6*TICRATE)-10)
			S_StartSound(nil,sfx_premon)
		end
		
		HU.racecountup = $+1
		
		//Refresh countdown to prevent the game from doing a hardcoded funni
		if HU.force
			K_SetRaceCountdown((HU.force*TICRATE)-HU.racecountup)
		else
			K_SetRaceCountdown((HU.pinchtime.value*TICRATE)-HU.racecountup)
		end
	else
	
		//Restore music if the countdown was ended or suddenly abrupted
		for player in players.iterate do
			player.heardpinch = false
			
			if HU.racecountup
				P_RestoreMusic(player)	
			end
		end
		
		HU.racecountup = 0
		HU.force = 0
		
	end
	
	//start countdown way earlier
	if HU.Happened or not HU.firsttrigger.value return end
	
	local playercount = 0-CV_FindVar("karteliminatelast").value
	local omg
	omg = false
	
	for player in players.iterate do
		if player.realtime
			playercount = $+1
		end
		if player.exiting
			omg = true
		end
	end
	
	if omg and playercount >= 2 then
		HU.racecountup = -HU.pinchtime.value
		K_SetRaceCountdown(HU.pinchtime.value*TICRATE)
	end
end